function Turtle() {
	this.strichBreite = 1;
	this.farbe = "#000000";
	this.stiftOben = false;
	this.orientierung = 0; //in rad; zeigt nach oben
	this.posX = 100;
	this.posY = 100;
	this.length = 8;
	this.breite = 3;
	this.textOffsetX = -10;
	this.textOffsetY = -10;
	this.stepSize = 10;

	//---------	Methode ----------------------
	this.getX = function() {return this.posX;};
	this.getY = function() {return this.posY;};

	this.cntSteps = 0;
	this.vor = this.forward = this.fd = function(dStep) {
		var deltaX = dStep*Math.sin(this.orientierung);
		var deltaY = dStep*Math.cos(this.orientierung);
		if (Math.abs(deltaX)<0.0001) deltaX = 0;
		if (Math.abs(deltaY)<0.0001) deltaY = 0;
		var newPosX = this.posX+deltaX;
		var newPosY = this.posY+deltaY;
		if (Math.abs(newPosX)<0.0001) newPosX = 0;
		if (Math.abs(newPosY)<0.0001) newPosY = 0;
		//p("Delta:"+deltaX+"|"+deltaY);
		//p("vor() Pos:"+newPosX+"|"+newPosY);
		if (!this.stiftOben) {
			jg.setColor(this.farbe);
			jg.setStroke(this.strichBreite);
			jg.drawLine(this.posX,this.posY,newPosX,newPosY);
			jg.paint();
		}
		this.posX = newPosX;
		this.posY = newPosY;
	};
	
	this.zurueck = this.back = function(dStep) {this.vor((-1)*dStep);};
	
	this.moveTo = this.nach = function(dX,dY) {
		this.posX = dX;
		this.posY = dY;
	};

	this.doStep = function(nbrSteps) {
		this.vor(nbrSteps*this.stepSize);
	}
	this.setStep = function(newStepSize) {
		this.stepSize = newStepSize;
	}
	this.getStep = function() {
		return this.stepSize;
	}

	this.drehen = this.links = this.left = function(dGrad) {//Grad in real or double
		var bogenmass = Math.PI*dGrad/180;
		this.orientierung += bogenmass;
	};
	
	this.rechts = this.right = function(dGrad) {this.drehen((-1)*dGrad);};
	
	this.drehenNach = this.turnTo = function(pntX,pntY) {
		var deltaX = Math.sin(this.orientierung);
		var deltaY = Math.cos(this.orientierung);
		var vectorA = new Array(deltaX,deltaY);
		var vectorB = new Array(pntX-this.posX,pntY-this.posY);
		var bogenmass = (vectorA[0]*vectorB[0]+vectorA[1]*vectorB[1])/(Math.sqrt(vectorA[0]*vectorA[0]+vectorA[1]*vectorA[1])*Math.sqrt(vectorB[0]*vectorB[0]+vectorB[1]*vectorB[1]));
		var grad = Math.floor(Math.acos(bogenmass)*180/Math.PI);
		var n_z = vectorA[0]*vectorB[1]-vectorA[1]*vectorB[0]; //z-Komponente des Normalenvektors
		if (n_z>0) grad *= -1;
		this.drehen(grad);
		return new Array(grad,vectorA,vectorB);
	}

	this.schauenNach = this.lookAt = function(turtle) {
		var deltaX = Math.sin(this.orientierung);
		var deltaY = Math.cos(this.orientierung);
		var vectorA = new Array(deltaX,deltaY);
		var vectorB = new Array(turtle.getX()-this.posX,turtle.getX()-this.posY);
		var bogenmass = (vectorA[0]*vectorB[0]+vectorA[1]*vectorB[1])/(Math.sqrt(vectorA[0]*vectorA[0]+vectorA[1]*vectorA[1])*Math.sqrt(vectorB[0]*vectorB[0]+vectorB[1]*vectorB[1]));
		var grad = Math.floor(Math.acos(bogenmass)*180/Math.PI);
		var n_z = vectorA[0]*vectorB[1]-vectorA[1]*vectorB[0];
		if (n_z>0) grad *= -1;
		return new Array(grad,vectorA,vectorB);
	}

	this.abstand = this.distance = function(pntX,pntY) {
		return Math.sqrt(Math.pow((this.posX-pntX),2)+Math.pow(this.posY-pntY,2));
	}
	
	this.abstandZu = this.distanceTo = function(turtle) {
		return Math.sqrt(Math.pow((this.posX-turtle.getX()),2)+Math.pow(this.posY-turtle.getY(),2));
	}

	this.stiftHoch = this.up = this.penUp = function() {
		this.stiftOben = true;
	}

	this.stiftRunter = this.down = this.penDown = function() {
		this.stiftOben = false;
	}

	this.farbeAendern = this.color = this.strokeColor = function(newColor) {
		this.farbe = newColor;
	}

	this.strichBreiteAendern = this.strokeWidth = function(newWidth) {
		this.strichBreite = newWidth;
	}
		
	this.drawTurtle = this.show = this.draw = function() {
		jg.setColor("#ff0000");
		jg.setStroke(1);
		
		//Rotation im Raum
		//x_neu = x_alt*cos - y_alt*sin
		//y_neu = x_alt*sin + y_alt*cos
		/*------------------------------
		
		   P1
		   | ----------
		   |           P3
		   | ----------
		   P2
		--------------------------------*/
		
		var curPosX = this.posX;
		var curPosY = this.posY;
		
		var deltaX = Math.cos(this.orientierung)*this.breite;
		var deltaY = Math.sin(this.orientierung)*this.breite;
		
		var p1_x = curPosX+deltaX;
		var p1_y = curPosY-deltaY;

		var p2_x = curPosX-deltaX;
		var p2_y = curPosY+deltaY;
		
		deltaX = Math.sin(this.orientierung)*this.length;
		deltaY = Math.cos(this.orientierung)*this.length;
		
		var p3_x = curPosX+deltaX;
		var p3_y = curPosY+deltaY;
		
		jg.drawLine(p1_x,p1_y,p2_x,p2_y);
		jg.drawLine(p2_x,p2_y,p3_x,p3_y);
		jg.drawLine(p3_x,p3_y,p1_x,p1_y);
		
		jg.paint();
		
	}
	
	
	this.drawText = this.schreibe = this.p = function(sText) {
		jg.setColor(this.farbe);
		jg.drawString(sText,this.posX+this.textOffsetX,this.posY+this.textOffsetY);
		jg.paint();
	}
	
	this.textOffset = function(iOffsetX,iOffsetY) {
		this.textOffsetX = iOffsetX;
		this.textOffsetY = iOffsetY;
	}
	
	this.resize = function (factor) {
		this.breite *= factor;
		this.length *= factor;
	}
	
	this.drawQuad = function (sideLength) {
		if (!this.stiftOben) {
			jg.setColor(this.farbe);
			jg.fillRect(this.posX,this.posY,sideLength,sideLength);
			jg.paint();
		}
	}
	
	this.zufall = this.rnd = function (u,o) {
		return Math.floor(Math.random()*(o-u+1))+u;
	}
	
	this.setBackgroundColor = this.hintergrund = function(newColor) {
		document.bgColor = newColor;
	}
	
	this.drawFilledRect = function(w,h,randFarbe) {
		if (!this.stiftOben) {
			jg.setColor(this.farbe);
			jg.fillRect(this.posX,this.posY, w, h);
			if (randFarbe!="") {
				jg.setColor(randFarbe);
				jg.drawRect(this.posX,this.posY, w, h);
			}
			jg.paint();
		}
	}
	
	this.drawImage = this.bildZeigen = function(imgSrc, w, h) {
		var picId = new Date().getTime();
		var sResult = '<div style="position:absolute;'+'left:' + this.posX + 'px;'+'top:' + this.posY + 'px;'+'width:' +  w + ';'+'height:' + h + ';">'+'<img src="' + imgSrc + '" id="'+picId+'" width="' + w + '" height="' + h + '">'+'<\/div>';
		jg.htm += sResult;
		jg.paint();
	}
}